/* parametrisiertes Fenster
ähnlich 60582, 60593, 60594
*/

$fn=100;
breite = 6; // mindestens 1
hoehe  = 3; // mindestens 1
// eisenbahn = 0

// Dimensionen; sollten nur zur Kalibrierung angepasst werden
SteinBreite   = 8.00;
SteinHoehe    = 9.60;
Luecke        = 0.10;
Luecken       = 2*Luecke;
Wandstaerke   = 1.40;
//Abrundung     = 0.1;

NoppenDaussen = 4.85; //V1=4.80
NoppenDinnen  = 3.35; //V1=3.25
NoppenHoehe   = 1.80;

BodenHoehe    = 2.25;//SteinHoehe/4.5;
BodenSeitRohr = 1.30; //alter Wert 1,20

l = SteinBreite * breite - Luecken;
b = SteinBreite * 1 - Luecken;
h = SteinHoehe * hoehe;


	difference() {
		// Grundform Stein
 /* klappt leider nicht       
		hull() {
            for (x= [-l/2+Abrundung/2,+l/2-Abrundung/2])
            {
                for (y=[-b/2+Abrundung/2,+b/2-Abrundung/2])
                {
                    for (z=[0+Abrundung/2,+h-Abrundung/2])
                        translate([x,y,z]) sphere($fn=10);
                }
            }
        }
*/

        translate([-l/2, -b/2 ,0]) {
			cube([l, b, h]);
		}
		// Noppenraum Boden
		translate([
			-l/2 + Wandstaerke,
			-b/2 + Wandstaerke,
			-0.0
		]) {
			cube([
				l - 2 * Wandstaerke,
				b - 2 * Wandstaerke,
				BodenHoehe
			]);
		}

		// Fensterausschnitt hinten
		translate([
			-l/2 + 2.1,
			-b/2,
			SteinHoehe/3
		]) {
			cube([
				SteinBreite*breite-SteinBreite/2-Luecken,
				SteinBreite-Luecken,
				SteinHoehe*hoehe-SteinHoehe/3-2.1
			]);
		}
        // Fensterausschnit vorne
        translate([
            -l/2 + Wandstaerke, 
            -b/2, 
            SteinHoehe/3
        ]) {
        cube([SteinBreite*breite-Wandstaerke*2-Luecken,     SteinHoehe/3, SteinHoehe*hoehe-SteinHoehe/3-Wandstaerke]);   
    }
    // Bohrung Fensterbefestigung wenn breite >= 2
    if (breite > 1) {
     for(x=[0:(breite-2)])
    {
        translate([
            - SteinBreite*breite / 2 + SteinBreite*(x+1), 
            -1.8, 
            0.0]) {
        cylinder(d=1.8, h=SteinHoehe*hoehe);
        };
    }
  };
     /*
  */
 };
 
//Noppen oben
 for(x=[0:(breite-1)])
 {
   translate([
     - SteinBreite*breite/2 + SteinBreite/2 + x*SteinBreite, 
     0.0 , 
     SteinHoehe*hoehe])
   difference()
   {
    cylinder(d=NoppenDaussen, h=NoppenHoehe);
    cylinder(d=NoppenDinnen,  h=NoppenHoehe);
   }
 };

/*
// Bodenröhrchen
 for(x=[0:(breite-3)])
 {
  translate([SteinBreite+x*SteinBreite, SteinBreite/2, 0])
    cylinder(d=3.2, h=2.5);
 };
 */
 
// Bodenröhrchen V2
 if (breite > 1)
 {
 for(x=[0:(breite*2-3)]) 
     //V1: for(x=[0:(breite*2-3)])
     //V2: for(x=[-1:(breite*2-2)])
 {
  RohrAbstand =
     sqrt(
     exp(ln(NoppenDaussen+BodenSeitRohr)*2)
     -exp(ln(SteinBreite/2)*2)
     ); 
     
  translate([
   -SteinBreite*breite/2+SteinBreite*0.75+x*SteinBreite/2, 
    RohrAbstand/2, 
    0.20])
   cylinder(d=BodenSeitRohr, h=BodenHoehe);
  translate([
   -SteinBreite*breite/2+SteinBreite*0.75+x*SteinBreite/2, 
    -RohrAbstand/2, 
    0.20])
    cylinder(d=BodenSeitRohr, h=BodenHoehe);
 } ;
 };
 